#ifndef EVENEMENT_H
#define EVENEMENT_H

#include "Incopiable.h"
#include <windows.h>

class Evenement
   : Incopiable
{
   HANDLE event_;
public:
   class ManualReset {};
   class AutomaticReset {};
   Evenement(ManualReset)
      : event_(CreateEvent(0, TRUE, FALSE, 0))
   {
   }
   Evenement(AutomaticReset)
      : event_(CreateEvent(0, FALSE, FALSE, 0))
   {
   }
   ~Evenement() throw()
      { CloseHandle(event_); }
   bool attendre() const throw()
      { WaitForSingleObject(event_, INFINITE); return true; }
   void provoquer() const throw()
      { SetEvent(event_); }
   void reinitialiser() const throw()
      { ResetEvent(event_); }
};

#endif
