#ifndef MUTEX_H
#define MUTEX_H

#include "Incopiable.h"
#include <windows.h>

class Mutex
   : Incopiable
{
   HANDLE mutex_;
public:
   Mutex() throw()
      : mutex_(CreateMutex(0, FALSE, 0))
   {
   }
   ~Mutex() throw()
      { CloseHandle(mutex_); }
   bool obtenir() const volatile throw()
      { return WaitForSingleObject(mutex_, INFINITE) == WAIT_OBJECT_0; }
   bool relacher () const volatile throw()
      { return ReleaseMutex(mutex_) != FALSE; }
};


/*
class Mutex
   : Incopiable
{
   mutable CRITICAL_SECTION mutex_;
public:
   Mutex() throw()
      { InitializeCriticalSection(&mutex_); }
   ~Mutex() throw()
      { DeleteCriticalSection(&mutex_); }
   bool obtenir() const volatile throw()
      { EnterCriticalSection(const_cast<CRITICAL_SECTION*>(&mutex_)); return true; }
   bool relacher () const volatile throw()
      { LeaveCriticalSection(const_cast<CRITICAL_SECTION*>(&mutex_)); return true; }
};
*/
class Autoverrou
{
   bool etat_;
   const volatile Mutex &mutex_;
public:
   Autoverrou(const volatile Mutex &m) throw()
      : mutex_(m)
   {
      etat_ = mutex_.obtenir();
   }
   ~Autoverrou() throw()
      { if (etat_) mutex_.relacher(); }
   operator bool() const volatile
      { return etat_; }
};
#endif
