
const char *terminaison(const bool pluriel)
{
   static const char * TERMINAISONS [] = { "", "s" };
   return TERMINAISONS[pluriel? 1 : 0];
}

const char *config()
{
#ifdef _DEBUG
   return "(DEBUG)";
#else
   return "(RELEASE)";
#endif
}

#include "compter_mots.h"
#include "compter_mots_seriel.h"
#include "compter_mots_map_reduce.h"
#include "minuterie.h"
#include <sstream>
#include <iostream>
#include <iterator>
#include <algorithm>

//void delegue_test();

int main(int argc, char *argv[])
{
   using std::stringstream;
   using std::endl;
   using std::ofstream;
   using std::copy;
   using std::ostream_iterator;
   ofstream sortie("out.txt");
   const int nb_docs = argc - 1;
   sortie << "Compter les mots, " << nb_docs
          << " document" << terminaison(argc > 2)
          << ' ' << config() << "\n\t";
   copy (argv + 1, argv + argc, ostream_iterator<char*>(sortie, "\n\t"));
   sortie << endl;
   {
      stringstream sstr;
      sortie << "Approche srielle" << endl;
      int n_seriel;
      { // version srielle
         minuterie minu(sstr);
         n_seriel = compter_mots_multidocuments_seriel(argv + 1, argv + argc);
      }
      sortie << '\t' << n_seriel << " mots au total" << endl;
      sortie << '\t' << sstr.str() << endl;
   }
   {
      stringstream sstr;
      sortie << "Approche map/ reduce" << endl;
      int n_map_reduce;
      { // version map/ reduce
         minuterie minu(sstr);
         n_map_reduce = compter_mots_multidocuments_map_reduce(argv + 1, argv + argc);
      }
      sortie << '\t' << n_map_reduce << " mots au total" << endl;
      sortie << '\t' << sstr.str() << endl;
   }
   //delegue_test();
}

//#include "delegue.h"
//
//int f()
//   { return 1; }
//int g(int)
//   { return 2; }
//int h(int, int)
//   { return 3; }
//int i(int, int, int)
//   { return 4; }
//struct X
//{
//   int f()
//      { return 5; }
//   int g(int)
//      { return 6; }
//   int h(int, int)
//      { return 7; }
//   int i(int, int, int)
//      { return 8; }
//   int j() const
//      { return 9; }
//   int k(int) const
//      { return 10; }
//   int l(int, int) const
//      { return 11; }
//   int m(int, int, int) const
//      { return 12; }
//};
//
//void delegue_test()
//{
//   delegue<int> d0 = creer_delegue(f);
//   delegue<int, int> d1 = creer_delegue(g);
//   delegue<int, int, int> d2 = creer_delegue(h);
//   delegue<int, int, int, int> d3 = creer_delegue(i);
//   X x;
//   delegue<int> m0 = creer_delegue(x, &X::f);
//   delegue<int, int> m1 = creer_delegue(x, &X::g);
//   delegue<int, int, int> m2 = creer_delegue(x, &X::h);
//   delegue<int, int, int, int> m3 = creer_delegue(x, &X::i);
//   delegue<int> m4 = creer_delegue(x, &X::j);
//   delegue<int, int> m5 = creer_delegue(x, &X::k);
//   delegue<int, int, int> m6 = creer_delegue(x, &X::l);
//   delegue<int, int, int, int> m7 = creer_delegue(x, &X::m);
//   using std::cout;
//   cout << d0() << endl;
//   cout << d1(1) << endl;
//   cout << d2(1,2) << endl;
//   cout << d3(1,2,3) << endl;
//   cout << m0() << endl;
//   cout << m1(1) << endl;
//   cout << m2(1,2) << endl;
//   cout << m3(1,2,3) << endl;
//   cout << m4() << endl;
//   cout << m5(1) << endl;
//   cout << m6(1,2) << endl;
//   cout << m7(1,2,3) << endl;
//}

//Tache *creer_bidon()
//{
//   struct Bidon : Tache
//   {
//      void faire()
//      {
//         cout << "Yo man" << endl;
//      }
//   };
//   return new Bidon;
//}
// CODE DE TEST, AU BESOIN
   //for (int i = 0; i < 10; ++i)
   //   thread_pool_::get().enfiler(creer_bidon());
