#ifndef COMPTER_MOTS_MAP_REDUCE_H
#define COMPTER_MOTS_MAP_REDUCE_H

#include "future.h"
#include "functional_ext.h"
#include "compter_mots_seriel.h"
#include <iterator>
#include <algorithm>

template <class Itt>
   class CompterMots
      : public nullary_function<int>
   {
      Itt debut_, fin_;
      result_type &cumul_;
   public:
      CompterMots(Itt debut, Itt fin, int &cumul)
         : debut_(debut), fin_(fin), cumul_(cumul)
      {
      }
      result_type operator()()
      {
         typename std::iterator_traits<Itt>::distance_type n =
            std::distance(debut_, fin_);
         if (n <= 4)
            cumul_ = compter_mots_multidocuments_seriel(debut_, fin_);
         else
         {
            Itt milieu = debut_;
            std::advance(milieu, n/2);
            int sommeA = 0, sommeB = 0;
            CompterMots tA (debut_, milieu, sommeA);
            CompterMots tB (milieu, fin_, sommeB);
            future<CompterMots<Itt> > fA(tA);
            future<CompterMots<Itt> > fB(tB);
            cumul_ = fA() + fB();
         }
         return cumul_;
      }
   };

template <class Itt>
   int compter_mots_multidocuments_map_reduce(Itt debut, Itt fin)
   {
      int somme = 0;
      CompterMots <Itt> t (debut, fin, somme);
      future<CompterMots<Itt> > f(t);
      return f();
   }

#endif
