#ifndef DELEGUE_H
#define DELEGUE_H


#include "static_assert.h"
#include "Vide.h"
#include "static_bool_int.h"
#include "static_switch.h"

class bad_function_call {};

//
// static_verification vrifie certaines occurrences de Vide dans
// une squence de types
//
template <int, class, class, class>
   struct static_verification;

template <class Arg0, class Arg1, class Arg2>
   struct static_verification<0, Arg0, Arg1, Arg2>
   {
      static const bool is_arg0_vide = static_type_est_vide<Arg0>::VAL;
      static const bool is_arg1_vide = static_type_est_vide<Arg1>::VAL;
      static const bool is_arg2_vide = static_type_est_vide<Arg2>::VAL;

      static_assert<is_arg0_vide> test0;
      static_assert<is_arg1_vide> test1;
      static_assert<is_arg2_vide> test2;
   };

template <class Arg0, class Arg1, class Arg2>
   struct static_verification<1, Arg0, Arg1, Arg2>
   {
      static const bool is_arg0_vide = static_type_est_vide<Arg0>::VAL;
      static const bool is_arg1_vide = static_type_est_vide<Arg1>::VAL;
      static const bool is_arg2_vide = static_type_est_vide<Arg2>::VAL;

      static_assert<!is_arg0_vide> test0;
      static_assert<is_arg1_vide> test1;
      static_assert<is_arg2_vide> test2;
   };

template <class Arg0, class Arg1, class Arg2>
   struct static_verification<2, Arg0, Arg1, Arg2>
   {
      static const bool is_arg0_vide = static_type_est_vide<Arg0>::VAL;
      static const bool is_arg1_vide = static_type_est_vide<Arg1>::VAL;
      static const bool is_arg2_vide = static_type_est_vide<Arg2>::VAL;

      static_assert<!is_arg0_vide> test0;
      static_assert<!is_arg1_vide> test1;
      static_assert<is_arg2_vide> test2;
   };

template <class Arg0, class Arg1, class Arg2>
   struct static_verification<3, Arg0, Arg1, Arg2>
   {
      static const bool is_arg0_vide = static_type_est_vide<Arg0>::VAL;
      static const bool is_arg1_vide = static_type_est_vide<Arg1>::VAL;
      static const bool is_arg2_vide = static_type_est_vide<Arg2>::VAL;

      static_assert<!is_arg0_vide> test0;
      static_assert<!is_arg1_vide> test1;
      static_assert<!is_arg2_vide> test2;
   };

template <class T0, class T1, class T2>
   struct nb_params_valides
   {
   // juste pour que ce ne soit pas trop long
   private:
      static const int t0 =
         static_int_from_bool<
            static_inverse_bool<
               static_type_est_vide<T0>::VAL
            >::VAL
         >::VAL;
      static const int t1 =
         static_int_from_bool<
            static_inverse_bool<
               static_type_est_vide<T1>::VAL
            >::VAL
         >::VAL;
      static const int t2 =
         static_int_from_bool<
            static_inverse_bool<
               static_type_est_vide<T2>::VAL
            >::VAL
         >::VAL;
   public:
      static const int VAL = t0+ t1 + t2;
      static static_verification<VAL, T0, T1, T2> nb_valides;
   };

// ICI: ci-dessous, destructeurs virtuels?

template <class R>
   struct delegue_base0
   {
      typedef R result_type;
      virtual result_type invoke() const = 0;
   };

template <class R, class Arg>
   struct delegue_base1
   {
      typedef R result_type;
      typedef Arg argument_type;
      virtual result_type invoke(argument_type) const = 0;
   };

template <class R, class Arg0, class Arg1>
   struct delegue_base2
   {
      typedef R result_type;
      typedef Arg0 first_argument_type;
      typedef Arg1 second_argument_type;
      virtual result_type invoke(first_argument_type, second_argument_type) const = 0;
   };

template <class R, class Arg0, class Arg1, class Arg2>
   struct delegue_base3
   {
      typedef R result_type;
      typedef Arg0 first_argument_type;
      typedef Arg1 second_argument_type;
      typedef Arg2 third_argument_type;
      virtual result_type invoke(first_argument_type, second_argument_type, third_argument_type) const = 0;
   };


template <class R, class T0, class T1, class T2>
   struct static_trouver_delegue_base
   {
   private:
      typedef delegue_base0<R> t0;
      typedef delegue_base1<R, T0> t1;
      typedef delegue_base2<R, T0, T1> t2;
      typedef delegue_base3<R, T0, T1, T2> t3;
      static const int VAL = nb_params_valides <T0, T1, T2>::VAL;
   public:
      typedef typename
         static_switch4<VAL, t0, t1, t2, t3>::type type;
   };

//
// Dtecteur de la sorte de fonction
//
template <class F, class R, class, class, class>
   struct general_fonction0
      : delegue_base0<R>
   {
      typedef F fct_type;
      explicit general_fonction0(fct_type fct)
         : fct_(fct)
      {
      }
      virtual result_type invoke() const
         { return fct_(); }
   private:
      mutable fct_type fct_;
   };

template <class F, class R, class Arg0, class, class>
   struct general_fonction1
      : delegue_base1 <R, Arg0>
   {
      typedef F fct_type;
      explicit general_fonction1(fct_type fct)
         : fct_(fct)
      {
      }
      virtual result_type invoke(argument_type arg) const
        { return fct_(arg); };
   private:
      mutable fct_type fct_;
   };

template <class F, class R, class Arg0, class Arg1, class>
   struct general_fonction2
      : delegue_base2 <R, Arg0, Arg1>
   {
      typedef F fct_type;
      explicit general_fonction2(fct_type fct)
         : fct_(fct)
      {
      }
      virtual result_type invoke(first_argument_type arg0, second_argument_type arg1) const
         { return fct_(arg0, arg1); }
   private:
      mutable fct_type fct_;
   };

template <class F, class R, class Arg0, class Arg1, class Arg2>
   struct general_fonction3
      : delegue_base3 <R, Arg0, Arg1, Arg2>
   {
      typedef F fct_type;
      explicit general_fonction3(fct_type fct)
         : fct_(fct)
      {
      }
      virtual result_type invoke(first_argument_type arg0, second_argument_type arg1, third_argument_type arg2) const
         { return fct_(arg0, arg1, arg2); }
   private:
      mutable fct_type fct_;
   };

template <class F, class R, class T0, class T1, class T2>
   struct static_trouver_general_fonction
   {
   private:
      typedef general_fonction0<F, R, T0, T1, T2> t0;
      typedef general_fonction1<F, R, T0, T1, T2> t1;
      typedef general_fonction2<F, R, T0, T1, T2> t2;
      typedef general_fonction3<F, R, T0, T1, T2> t3;
      static const int nb_valides = nb_params_valides <T0, T1, T2>::VAL;
   public:
      typedef typename static_switch4<nb_valides, t0, t1, t2, t3>::type type;
   };

//
// Dtecteur de la sorte de mthode d'instance
//

   // ceci n'est pas bon, mais pas bon du tout, j'ai fait l'erreur en class je pense
   // ici on accpete juste Retour(Type::*methode_type)(); et pas Retour(Type::*methode_type)() const;
   // c'est pas bon

   //template <class Type, class Retour, class Arg1, class Arg2, class Arg3>
   //   struct general_methode0 : delegue_base0 <Retour>
   //   {
   //      typedef Type this_type;
   //      typedef Retour(Type::*methode_type)();
   //      explicit general_methode0(this_type* le_this, methode_type methode)
   //         : this_(le_this), methode_(methode) {}
   //      virtual result_type invoke() const { return (this_->*methode_)(); };
   //   private:
   //      this_type* this_;
   //      methode_type methode_;
   //   };

template <class T, class M, class R, class Arg0, class Arg1, class Arg2>
   struct general_methode0
      : delegue_base0 <R>
   {
      typedef T this_type;
      typedef M methode_type;
      explicit general_methode0(this_type* t, methode_type m)
         : this_(t), methode_(m)
      {
      }
      virtual result_type invoke() const
         { return (this_->*methode_)(); }
   private:
      mutable this_type* this_;
      methode_type methode_;
   };

template <class T, class M, class R, class Arg0, class Arg1, class Arg2>
   struct general_methode1
      : delegue_base1 <R, Arg0>
   {
      typedef T this_type;
      typedef M methode_type;
      explicit general_methode1(this_type* t, methode_type m)
         : this_(t), methode_(m)
      {
      }
      virtual result_type invoke(argument_type arg) const
         { return (this_->*methode_)(arg); }
   private:
      mutable this_type* this_;
      methode_type methode_;
   };

template <class T, class M, class R, class Arg0, class Arg1, class Arg2>
   struct general_methode2
      : delegue_base2 <R, Arg0, Arg1>
   {
      typedef T this_type;
      typedef M methode_type;
      explicit general_methode2(this_type* t, methode_type m)
         : this_(t), methode_(m)
      {
      }
      virtual result_type invoke(first_argument_type arg0, second_argument_type arg1) const
         { return (this_->*methode_)(arg0, arg1); };
   private:
      mutable this_type* this_;
      methode_type methode_;
   };

template <class T, class M, class R, class Arg0, class Arg1, class Arg2>
   struct general_methode3
      : delegue_base3 <R, Arg0, Arg1, Arg2>
   {
      typedef T this_type;
      typedef M methode_type;
      explicit general_methode3(this_type* t, methode_type m)
         : this_(t), methode_(m)
      {
      }
      virtual result_type invoke(first_argument_type arg0, second_argument_type arg1, third_argument_type arg2) const
         { return (this_->*methode_)(arg0, arg1, arg2); };
   private:
      mutable this_type* this_;
      methode_type methode_;
   };

template <class T, class M, class R, class T0, class T1, class T2>
   struct static_trouver_general_methode
   {
   private:
      typedef general_methode0<T, M, R, T0, T1, T2> t0;
      typedef general_methode1<T, M, R, T0, T1, T2> t1;
      typedef general_methode2<T, M, R, T0, T1, T2> t2;
      typedef general_methode3<T, M, R, T0, T1, T2> t3;
      static const int nb_valides = nb_params_valides <T0, T1, T2>::VAL;
   public:
      typedef typename
         static_switch4<nb_valides, t0, t1, t2, t3>::type type;
   };



template <class R, class Arg0, class Arg1, class Arg2>
   struct delegue;

template <class R, class Arg0 = Vide, class Arg1 = Vide, class Arg2 = Vide>
   struct delegue
   {
      typedef R result_type;
      typedef Arg0 first_argument_type;
      typedef Arg1 second_argument_type;
      typedef Arg2 third_argument_type;
      static const int nombre_argument_valide =
         nb_params_valides<Arg0, Arg1, Arg2>::VAL;
      typedef typename
         static_trouver_delegue_base<R, Arg0, Arg1, Arg2>::type delegue_base_type;
      // La Sainte-Trinit s'applique
      explicit delegue() throw() : delegue_(0) {} // null_ptr

      template <class F>
         explicit delegue(F fct)
            : delegue_(0) 
         {
            typedef typename
               static_trouver_general_fonction<F, R, Arg0, Arg1, Arg2>::type delegue_function_type;
            delegue_ = new typename delegue_function_type(fct);
         }
      template <class T, class M>
         explicit delegue(T* type, M methode)
            : delegue_(0)
         {
            typedef typename
               static_trouver_general_methode<T, M, R, Arg0, Arg1, Arg2>::type delegue_methode_type;
            delegue_ = new typename delegue_methode_type(type, methode);
         }

      result_type operator()() const
      {
         _verifie_delegue();
         return delegue_->invoke();
      }
      result_type operator()(first_argument_type arg) const
      {
         _verifie_delegue();
         return delegue_->invoke(arg);
      }
      result_type operator()(first_argument_type arg0, second_argument_type arg1) const
      {
         _verifie_delegue();
         return delegue_->invoke(arg0, arg1);
      }
      result_type operator()(first_argument_type arg0, second_argument_type arg1, third_argument_type arg2) const
      {
         _verifie_delegue();
         return delegue_->invoke(arg0, arg1, arg2);
      }

      bool empty() const
         { return !delegue_; }

      bool is_from_the_same_base(const delegue& value) const
         { return value.delegue_ == delegue_; }
      bool operator==(const delegue&)
         const; // can't be implemented
      bool operator!=(const delegue&)
         const; // can't be implemented
      ~delegue() throw()
         { delete delegue_; }
   private:
      void _verifie_delegue() const
         { if(empty()) throw bad_function_call(); }
   private:
      //std::shared_ptr<delegue_base_type> delegue_;
      delegue_base_type* delegue_;
   };

template <class R>
   delegue<R> creer_delegue(R (f)())
      { return delegue<R>(f); }
template <class R, class T0>
   delegue<R, T0> creer_delegue(R (f)(T0))
      { return delegue<R, T0>(f); }
template <class R, class T0, class T1>
   delegue<R, T0, T1> creer_delegue(R (f)(T0, T1))
      { return delegue<R, T0, T1>(f); }
template <class R, class T0, class T1, class T2>
   delegue<R, T0, T1, T2> creer_delegue(R (f)(T0, T1, T2))
      { return delegue<R, T0, T1, T2>(f); }
template <class R, class T>
   delegue<R> creer_delegue(T &x, R (T::*f)())
      { return delegue<R>(&x, f); }
template <class R, class T, class T0>
   delegue<R, T0> creer_delegue(T &x, R (T::*f)(T0))
      { return delegue<R, T0>(&x, f); }
template <class R, class T, class T0, class T1>
   delegue<R, T0, T1> creer_delegue(T &x, R (T::*f)(T0, T1))
      { return delegue<R, T0, T1>(&x, f); }
template <class R, class T, class T0, class T1, class T2>
   delegue<R, T0, T1, T2> creer_delegue(T &x, R (T::*f)(T0, T1, T2))
      { return delegue<R, T0, T1, T2>(&x, f); }
template <class R, class T>
   delegue<R> creer_delegue(T &x, R (T::*f)() const)
      { return delegue<R>(&x, f); }
template <class R, class T, class T0>
   delegue<R, T0> creer_delegue(T &x, R (T::*f)(T0) const)
      { return delegue<R, T0>(&x, f); }
template <class R, class T, class T0, class T1>
   delegue<R, T0, T1> creer_delegue(T &x, R (T::*f)(T0, T1) const)
      { return delegue<R, T0, T1>(&x, f); }
template <class R, class T, class T0, class T1, class T2>
   delegue<R, T0, T1, T2> creer_delegue(T &x, R (T::*f)(T0, T1, T2) const)
      { return delegue<R, T0, T1, T2>(&x, f); }

#endif
