#ifndef FUNCTIONAL_EXT_H
#define FUNCTIONAL_EXT_H

#include <functional>

template <class F>
   struct unary_function_traits
   {
      typedef typename
         F::argument_type argument_type;
      typedef typename
         F::result_type result_type;
   };

template <class A, class R>
   struct unary_function_traits<R (*)(A)>
   {
      typedef A argument_type;
      typedef R result_type;
   };

template <class R>
   struct nullary_function
      : std::unary_function<void, R>
   {
   };

#endif
