#ifndef FUTURE_H
#define FUTURE_H

#include "functional_ext.h"
#include "TacheHolder.h"
#include "thread_pool.h"

//
// ICI:  faire: rendre future<F> incopiable ou partager fct_ 
//
template <class F>
   class future
   {
   public:
      typedef typename
         unary_function_traits<F>::result_type result_type;
   private:
      TacheHolder<F> *fct_;
   public:
      future(F fct)
         : fct_(new TacheHolder<F>(fct))
      {
         thread_pool_::get().enfiler(fct_);
      }
      ~future() throw()
         { delete fct_; }
      result_type operator()() const
         { fct_->attendre(); return fct_->result(); }
      operator bool() const
         { return fct_->complete(); }
   };

#endif

