#ifndef THREAD_POOL_H
#define THREAD_POOL_H

#include "Incopiable.h"
#include "Worker.h"
#include "Mutex.h"
#include <algorithm>
using std::for_each;
using std::transform;
#include <queue>
using std::queue;
#include <windows.h> // isoler quand j'aurai deux minutes

template <int N>
   class thread_pool
      : Incopiable
   {
      HANDLE h_[N];
      Worker worker_[N];
      thread_pool()
      {
         struct creer
         {
            Worker *base_;
            creer(Worker *base)
               : base_(base)
            {
            }
            HANDLE operator()(HANDLE)
               { return CreateThread(0, 0, ze_thread, base_++, CREATE_SUSPENDED, 0); }
         };
         transform (h_, h_ + N, h_, creer(worker_));
         for_each (h_, h_ + N, ResumeThread);
      }
      static thread_pool singleton;
      Mutex mutex_;
      queue<Tache *> taches_;
   public:
      bool empty() const
      {
         Autoverrou av(mutex_);
         return av && taches_.empty();
      }
      bool enfiler(Tache *p)
      {
         if (p)
         {
            Autoverrou av(mutex_);
            if (av)
               taches_.push(p);
            return true;
         }
         return false;
      }
      Tache * prochaine()
      {
         Autoverrou av(mutex_);
         if (av && !taches_.empty())
         {
            Tache *p = taches_.front();
            taches_.pop();
            return p;
         }
         return 0;
      }
      ~thread_pool() throw()
      {
         while (!empty())
            ;
         struct stop_work
         {
            void operator()(Worker &w)
               { w.stop(); }
         };
         for_each(worker_, worker_ + N, stop_work());
         for_each(h_, h_ + N, CloseHandle);
      }
      static thread_pool & get() throw()
         { return singleton; }
   };

typedef thread_pool<64> thread_pool_;

#endif
